<i18n>
{
  "fr": {
    "title": "Comparez les BGES",
    "info-1": "Selectionnez les BGES à comparer ainsi que l'année des facteurs d'émissions que vous souhaitez utiliser pour réaliser le calcul des émissions. Par défaut, l'année des facteurs d'émissions utilisée est celle de l'année du BGES. Cependant, utiliser la même année pour tous les BGES permet de visualiser l'évolution des émissions propres à l'activité du laboratoire, sans prendre en compte l'évolution des facteurs d'émissions eux-mêmes.",
    "field-1": "Années des BGES à comparer",
    "field-2": "Ajouter un BGES",
    "field-3": "Année des facteurs d'émissions",
    "field-4": "Année du BGES",
    "field-5": "Mode d'affichage"
  },
  "en": {
    "title": "Compare GHG inventories",
    "info-1": "Select the years of the GHG inventories that you want to compare, as well as the year of the emission factors that you want to use for the emissions calculation. By default, the year used for the emission factors is the year of each GHG inventory. Still, using the same base year for all the GHG inventories allows you to compare the changes in the emissions due to the activity of the laboratory, without accounting for changes in the emission factors",
    "field-1": "Years of the GHG inventories for comparison",
    "field-2": "Add a GHG inventory",
    "field-3": "Year of the emission factors",
    "field-4": "Year of the GHG inventory",
    "field-5": "Display mode"
  }
}
</i18n>

<template>
  <div>
    <su-service :icon="'line-chart'">
      <template #title>
        {{ $t('title') }}
      </template>
      {{ $t('info-1') }}
    </su-service>
    <br />
    <b-notification :closable="false">
      <div class="columns">
        <div class="column">
          <b-field :label="$t('field-1')">
            <b-taginput
              v-model="GHGIToCompare"
              :data="allGHGI"
              :allow-new="false"
              rounded
              @input="computeGHGI"
              autocomplete
              :open-on-focus="true"
              field="year"
              icon="caret-right"
              :placeholder="$t('field-2')"
            ></b-taginput>
          </b-field>
        </div>
        <div class="column">
          <b-field :label="$t('field-3')">
            <b-select
              expanded
              @input="computeGHGI"
              v-model="selectedEFYear"
            >
              <option :value="null">{{ $t('field-4') }}</option>
              <option
                :value="year"
                v-for="(year,index) in allEFYears"
                :key="index"
              >{{ year }}</option>
            </b-select>
          </b-field>
        </div>
        <div class="column is-3">
          <b-field :label="$t('field-5')">
            <b-radio-button v-model="displayMode"
                native-value="bar"
                expanded
                type="is-primary"
            >
              <b-icon icon="bar-chart"></b-icon>
              <span>Bar</span>
            </b-radio-button>
            <b-radio-button v-model="displayMode"
                expanded
                native-value="line"
            >
              <b-icon icon="line-chart"></b-icon>
              <span>Line</span>
            </b-radio-button>
          </b-field>
        </div>
      </div>
    </b-notification>
    <contrails-switch
      :withContrails.sync="withContrails"
      @input="computeGHGI"
    />
    <br />
    <highcharts
      v-show="displayMode==='bar'"
      :options="chartsOptions"
    />
    <highcharts
      v-show="displayMode==='line'"
      :options="lineOptions"
    />
  </div>
</template>

<script>
import {
  HEATING_COLOR,
  ELECTRICITY_COLOR,
  REFRIGERANTS_COLOR,
  VEHICLES_COLOR,
  TRAVELS_COLOR,
  COMMUTES_COLOR,
  COMPUTERDEVICES_COLOR,
  PURCHASES_COLOR
} from '@/models/definitions.js'
import VEHICLES_FACTORS from '@/../data/vehiclesFactors.json'
import TRANSPORTS_FACTORS from '@/../data/transportsFactors.json'
import HEATING_FACTORS from '@/../data/heatingFactors.json'
import ELECTRICITY_FACTORS from '@/../data/electricityFactors.json'
import REFRIGERANTS_FACTORS from '@/../data/refrigerantsFactors.json'
import '@/plugins/highcharts.js'

export default {
  name: 'GHGIComparison',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'contrails-switch': () => import('@/components/carbon/utils/ContrailsSwitch.vue')
  },
  data () {
    return {
      selectedEFYear: null,
      GHGIToCompare: [],
      withContrails: true,
      displayMode: 'bar',
      chartsOptions: {
        chart: {
          type: 'column'
        },
        title: {
          text: ''
        },
        credits: {
          enabled: false
        },
        series: [],
        tooltip: {
          valueSuffix: ' ' + this.$t('t.co2e'),
          valueDecimals: 2,
          shared: true
        },
        xAxis: {
          categories: [
            this.$t('heating'),
            this.$t('electricity'),
            this.$t('refrigerants'),
            this.$t('vehicles'),
            this.$t('travels'),
            this.$t('commutes'),
            this.$t('computer.devices'),
            this.$t('purchases')
          ],
          crosshair: true
        },
        yAxis: {
          min: 0,
          title: {
            text: this.$t('emissions.t.co2e')
          }
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        }
      },
      lineOptions: {
        title: {
          text: ''
        },
        credits: {
          enabled: false
        },
        tooltip: {
          valueSuffix: ' ' + this.$t('t.co2e'),
          valueDecimals: 2,
          shared: true
        },
        yAxis: {
          title: {
            text: this.$t('emissions.t.co2e')
          }
        },
        xAxis: {
          categories: []
        },
        series: [],
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          }
        }
      }
    }
  },
  computed: {
    allGHGI: function () {
      return this.$store.getters['admin/allGHGI']
    },
    sortedGHGIToCompare: function () {
      return this.GHGIToCompare.sort((a, b) => (a.year > b.year) ? 1 : ((b.year > a.year) ? -1 : 0))
    },
    allEFYears: function () {
      let allEFYears = []
      for (let type of Object.keys(VEHICLES_FACTORS)) {
        for (let subtype of Object.keys(VEHICLES_FACTORS[type])) {
          allEFYears = allEFYears.concat(Object.keys(VEHICLES_FACTORS[type][subtype].decomposition))
        }
      }
      for (let type of Object.keys(TRANSPORTS_FACTORS)) {
        for (let subtype of Object.keys(TRANSPORTS_FACTORS[type])) {
          allEFYears = allEFYears.concat(Object.keys(TRANSPORTS_FACTORS[type][subtype].decomposition))
        }
      }
      for (let type of Object.keys(HEATING_FACTORS)) {
        for (let subtype of Object.keys(HEATING_FACTORS[type])) {
          allEFYears = allEFYears.concat(Object.keys(HEATING_FACTORS[type][subtype].decomposition))
        }
      }
      for (let type of Object.keys(ELECTRICITY_FACTORS)) {
        allEFYears = allEFYears.concat(Object.keys(ELECTRICITY_FACTORS[type].decomposition))
      }
      for (let type of Object.keys(REFRIGERANTS_FACTORS)) {
        allEFYears = allEFYears.concat(Object.keys(REFRIGERANTS_FACTORS[type].decomposition))
      }
      return Array.from(new Set(allEFYears)).sort((a, b) => parseInt(b) - parseInt(a))
    }
  },
  methods: {
    computeGHGI: function () {
      this.$store.dispatch('admin/computeAllGHGI', this.selectedEFYear)
      this.updateChartsOptions()
    },
    updateChartsOptions: function () {
      this.chartsOptions.series = []
      for (let ghgi of this.sortedGHGIToCompare) {
        let travelsIntensity = ghgi.emissions.travels.intensity.intensity
        if (this.withContrails) {
          travelsIntensity = ghgi.emissions.travels.intensity.intensitywc
        }
        this.chartsOptions.series.push({
          name: ghgi.year,
          data: [
            ghgi.emissions.buildings.heatings.intensity.intensity / 1000,
            ghgi.emissions.buildings.electricity.intensity / 1000,
            ghgi.emissions.buildings.refrigerants.intensity / 1000,
            ghgi.emissions.vehicles.intensity.intensity / 1000,
            travelsIntensity / 1000,
            ghgi.emissions.commutes.intensity.intensity / 1000,
            ghgi.emissions.devices.intensity.intensity / 1000,
            ghgi.emissions.purchases.intensity.intensity / 1000
          ]
        })
      }
      let travelsIntensity = this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.travels.intensity.intensity / 1000)
      if (this.withContrails) {
        travelsIntensity = this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.travels.intensity.intensitywc / 1000)
      }
      this.lineOptions.series = [{
        name: this.$t('heating'),
        data: this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.buildings.heatings.intensity.intensity / 1000),
        color: HEATING_COLOR
      }, {
        name: this.$t('electricity'),
        data: this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.buildings.electricity.intensity / 1000),
        color: ELECTRICITY_COLOR
      }, {
        name: this.$t('refrigerants'),
        data: this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.buildings.refrigerants.intensity / 1000),
        color: REFRIGERANTS_COLOR
      }, {
        name: this.$t('vehicles'),
        data: this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.vehicles.intensity.intensity / 1000),
        color: VEHICLES_COLOR
      }, {
        name: this.$t('travels'),
        data: travelsIntensity,
        color: TRAVELS_COLOR
      }, {
        name: this.$t('commutes'),
        data: this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.commutes.intensity.intensity / 1000),
        color: COMMUTES_COLOR
      }, {
        name: this.$t('computer.devices'),
        data: this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.devices.intensity.intensity / 1000),
        color: COMPUTERDEVICES_COLOR
      }, {
        name: this.$t('purchases'),
        data: this.sortedGHGIToCompare.map(ghgi => ghgi.emissions.purchases.intensity.intensity / 1000),
        color: PURCHASES_COLOR
      }]
      this.lineOptions.xAxis.categories = this.sortedGHGIToCompare.map(ghgi => ghgi.year)
    },
    initiGHGIToCompare: function () {
      this.GHGIToCompare = this.allGHGI
    }
  },
  watch: {
    GHGIToCompare: function () {
      this.computeGHGI()
    },
    allGHGI: function () {
      this.initiGHGIToCompare()
      this.updateChartsOptions()
    },
    '$i18n.locale': function () {
      this.updateChartsOptions()
      this.chartsOptions.xAxis.categories = [
        this.$t('heating'),
        this.$t('electricity'),
        this.$t('refrigerants'),
        this.$t('vehicles'),
        this.$t('travels'),
        this.$t('commutes'),
        this.$t('computer.devices'),
        this.$t('purchases')
      ]
      this.chartsOptions.tooltip.valueSuffix = ' ' + this.$t('kg.co2e')
      this.chartsOptions.yAxis.title.text = this.$t('emissions.kg.co2e')
    }
  },
  mounted () {
    this.initiGHGIToCompare()
    this.updateChartsOptions()
  }
}
</script>

<style>
.is-sticky {
  background: #fafafa !important;
}
.table td {
  vertical-align: middle !important;
}
.table th {
  vertical-align: middle !important;
}
</style>
